#include "support/Iswitch.h"
#ifdef binary

#include "support/gcc8_c_support.h"
#include <proto/exec.h>

#include "Iset.h"

struct ExecBase *SysBase;

/* Values used by both exe and binary */
static short decayTable[128] = { 32767, 32767, 32767, 16384, 10922, 8192, 6553, 4681, 3640, 2978, 2520, 2048, 1724, 1489, 1310, 1129, 992,
885, 799, 712, 642, 585, 537, 489, 448, 414, 385, 356, 330, 309, 289, 270, 254, 239, 225, 212, 201, 190, 181, 171, 163, 155, 148, 141, 134,
129, 123, 118, 113, 108, 104, 100, 96, 93, 89, 86, 83, 80, 77, 75, 72, 70, 68, 65, 63, 61, 60, 58, 56, 54, 53, 51, 50, 49, 47, 46, 45, 44,
43, 41, 40, 39, 38, 38, 37, 36, 35, 34, 33, 33, 32, 31, 30, 30, 29, 29, 28, 27, 27, 26, 26, 25, 25, 24, 24, 23, 23, 22, 22, 22, 21, 21, 20,
20, 20, 19, 19, 19, 18, 18, 18, 17, 17, 17, 17, 16, 16, 16 };

static short counter_saw[16];
static short counter_sh[16];
static short counter_tri[16];
static short counter_sine[16];
static short counter_pulse[16];
static short buffer_sh[16];
static short ADSR_Mode[16];			
static int ADSR_Value[16];			
static int ADSR_SustainCounter[16];	
static short filterBuffer[16 * 4];


void synth(void* ModAdr, short(*buffern)[2048], void* ImpAdr, char* progress){

	SysBase = *((struct ExecBase**)4UL);

	#include "synthnodes.h"

	int SmpLength[31];
	int ImpLength[8];
	WORD repeat_offset[31];
	WORD repeat_length[31];
	UBYTE samplename_flag[31];

	#include "Ilen.h"
	
	int inst_count = numinstruments;
	int instrument;
	int smp;
	short v1, v2, v3, v4;

	void* BaseAdr[32];
	BaseAdr[0] = ModAdr;
	for (instrument = 0; instrument<inst_count; instrument++)
	{
		BaseAdr[instrument + 1] = BaseAdr[instrument] + SmpLength[instrument];
	}

	BYTE last = 0;
	for (int i = 0; i < imp_length; i++)
	{
		BYTE delta = *(BYTE*)(ImpAdr + i);
		*(BYTE*)(ImpAdr + i) = delta + last;
		last = *(BYTE*)(ImpAdr + i);
	}

	void* BaseImpAdr[8];
	BaseImpAdr[0] = ImpAdr;
	for (int k = 0; k<7; k++)
	{
		BaseImpAdr[k + 1] = BaseImpAdr[k] + ImpLength[k];
	}


	for (instrument = 0; instrument<inst_count; instrument++)
	{
		*progress = (char)instrument;
		clr_buf();
		v1 = 0; v2 = 0; v3 = 0; v4 = 0;
		for (smp = 0; smp <= SmpLength[instrument]; smp++)
		{
			#include "Inst.h"
			v1 >>= 8;
			*(BYTE*)(BaseAdr[instrument] + smp) = v1;
		}
		if (samplename_flag[instrument] == 'l')
		{
			loopgen(repeat_length[instrument], repeat_offset[instrument], BaseAdr[instrument]);
		}
		*(BYTE*)(BaseAdr[instrument]) = 0;
		*(BYTE*)(BaseAdr[instrument] + 1) = 0;
	}
}

int main();

__attribute__((used)) __attribute__((section(".text.unlikely")))
void _start()
{
	register void* smplocation asm("a0");
	register short(*buffer1)[2048] asm("a1");
	register void* implocation asm("a2");
	register char* prog asm("a4");
	synth(smplocation, buffer1, implocation, prog);

}


//////////////////////////
#endif /* ifbinary */

