#pragma once

#include "Iswitch.h"


#ifdef executable

#define offsetof(st, m) __builtin_offsetof(st, m)

void *memcpy (void *, const void *, unsigned long);
void *memset (void *, int, unsigned long);
void *memmove (void *, const void *, unsigned long);
unsigned long strlen (const char *);
void warpmode(int on); // bool on/off
void KPrintF(const char* fmt, ...); // output to debugger

// WinUAE debug overlay, coordinates are PAL-based (0,0)-(768,576)
void debug_clear();
void debug_rect(short left, short top, short right, short bottom, unsigned int color);
void debug_filled_rect(short left, short top, short right, short bottom, unsigned int color);
void debug_text(short left, short top, const char* text, unsigned int color);

#define INCBIN(name, file) INCBIN_SECTION(name, file, ".rodata", "")
#define INCBIN_CHIP(name, file) INCBIN_SECTION(name, file, ".INCBIN.MEMF_CHIP", "aw")
#define INCBIN_SECTION(name, file, section, flags) \
    __asm__(".pushsection " #section ", " #flags "\n" \
            ".global incbin_" #name "_start\n" \
            ".type incbin_" #name "_start, @object\n" \
            ".balign 2\n" \
            "incbin_" #name "_start:\n" \
            ".incbin \"" file "\"\n" \
            \
            ".global incbin_" #name "_end\n" \
            ".type incbin_" #name "_end, @object\n" \
            ".size incbin_" #name "_start, incbin_" #name "_end - incbin_" #name "_start\n" \
            ".balign 1\n" \
            "incbin_" #name "_end:\n" \
            ".byte 0\n" \
			".popsection\n" \
    ); \
    extern const __attribute__((aligned(2))) char incbin_ ## name ## _start[1024*1024]; \
	extern const void* incbin_ ## name ## _end;\
    const void* name = &incbin_ ## name ## _start;

#endif


inline unsigned int muluw(unsigned short b,unsigned short c) {
    unsigned short a;
    asm("muluw %2,%0":"=d"(a): "0"(c),"d"(b): "cc");
    return a;
}

inline int mulsw(short b,short c) {
    int a;
    asm("mulsw %2,%0":"=d"(a): "0"(c),"d"(b): "cc");
    return a;
}

inline int divsw(int c,short b) {
    short a;
    asm("divsw %2,%0":"=d"(a): "0"(c),"d"(b): "cc");
    return a;
}

inline int divuw(int c,short b) {
    short a;
    asm("divuw %2,%0":"=d"(a): "0"(c),"d"(b): "cc");
    return a;
}
